﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.DataPresenter;
using Infragistics.Windows;
using System.Windows.Forms;
using System.Collections.ObjectModel;

namespace xamDataGridExtendedSaveCustomization
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        bool[] isExpand;
        string layout;
        Double position;
        //CustomCalculator calculator = new CustomCalculator();

        public MainWindow()
        {
            InitializeComponent();
            //calculator.amount = 200;
            //SummaryCalculator.Register(calculator);
            ObservableCollection<Double> coll = new ObservableCollection<Double>();
            coll.Add(50);
            coll.Add(50);
            coll.Add(50);
            xamDataGrid1.DataSource = coll;
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            isExpand = new bool[xamDataGrid1.Records.Count];
            for (int i = 0; i < xamDataGrid1.Records.Count; i++)
            {
                if (xamDataGrid1.Records[i].IsExpanded == true)
                    isExpand[i] = true;
                else
                    isExpand[i] = false;
            }
            position = (Utilities.GetDescendantFromType(xamDataGrid1, typeof(ScrollViewer), true) as ScrollViewer).ContentVerticalOffset;
            layout = xamDataGrid1.SaveCustomizations();
        }

        private void button2_Click(object sender, RoutedEventArgs e)
        {
            xamDataGrid1.LoadCustomizations(layout);            
            for (int i = 0; i < xamDataGrid1.Records.Count; i++)
            {
                xamDataGrid1.Records[i].IsExpanded = isExpand[i];
            }
            (Utilities.GetDescendantFromType(xamDataGrid1, typeof(ScrollViewer), true) as ScrollViewer).ScrollToVerticalOffset(position);
        }

        static CustomCalculator _SelectedSum;
        public static CustomCalculator SelectedSum
        {
            get
            {
                if (_SelectedSum == null)
                {
                    _SelectedSum = new CustomCalculator();
                }

                return _SelectedSum;
            }
        }
    }
}
